$ ======================================================================
$
$   TOPPERS/HRP Kernel
$       Toyohashi Open Platform for Embedded Real-Time Systems/
$       High Reliable system Profile Kernel
$
$   Copyright (C) 2011-2012 by Embedded and Real-Time Systems Laboratory
$               Graduate School of Information Science, Nagoya Univ., JAPAN
$  
$   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
$   ܥեȥѤΤޤࡥʲƱˤѡʣ
$   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
$   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
$       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
$       ˴ޤޤƤ뤳ȡ
$   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
$       ѤǤǺۤˤϡۤȼɥȡ
$       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
$       ̵ݾڵǺܤ뤳ȡ
$   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
$       ѤǤʤǺۤˤϡΤ줫ξ
$       ȡ
$     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
$         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
$     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
$         𤹤뤳ȡ
$   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
$       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
$       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
$       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
$       դ뤳ȡ
$  
$   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
$   TOPPERSץȤϡܥեȥ˴ؤơλŪ
$   ФŬޤơʤݾڤԤʤޤܥեȥ
$   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
$   Ǥʤ
$
$ =====================================================================

$INCLUDE "kernel/kernel_mem.tf"$

$FILE "kernel_mem.c"$

$ 
$  ݸɥᥤΥǥեȤΥĥѥκ
$ 
$DEFAULT_ACPTN[TDOM_KERNEL] = VALUE("TACP_KERNEL", TACP_KERNEL)$
$FOREACH domid DOM.ID_LIST$
	$DEFAULT_ACPTN[domid] = VALUE(FORMAT("TACP(%1%)", domid), 1 << (domid - 1))$
$END$
$DEFAULT_ACPTN[TDOM_NONE] = VALUE("TACP_SHARED", TACP_SHARED)$

$ 
$  ڡơ֥ξ
$  ڡݸ°Ϥ
$ 
$  ͥɥᥤΥڡơ֥

const uint32_t page_table_info_kernel[$tsize_meminib$] = {$NL$
$IF !LENGTH(suppresszero)$
    $TAB$(uint32_t)0x0U,$NL$
$END$
$JOINEACH moid MO_MEMTOP_ORDER ",\n"$
    $page_table_entry = 0$
    $page_mp_info = 0$
    $IF !LENGTH(MO.SUPPRESSSTART[moid])$
        $IF MO.TYPE[moid] != TOPPERS_USTACK$
$           // 桼åʳ
            $page_table_entry = 0x00000000$

$           // ֥ͭӥåȤ򥻥åȤ
$           // ̵°Υꥪ֥Ȥʤж֥ͭӥåȤΩƤ
            $IF (MO.ACPTN2[moid] == DEFAULT_ACPTN[TDOM_NONE])$
                $IF (((MO.MEMATR[moid] & TA_NOWRITE) != 0) || ((MO.ACPTN1[moid] == DEFAULT_ACPTN[TDOM_NONE])))$
                    $page_table_entry = page_table_entry | (0x01 << 1)$
                $END$
            $END$

$           // ݸǡΰ򥻥åȤ
            $IF (MO.MEMATR[moid] & TA_NOWRITE) == 0$
                $IF (page_table_entry & 0x02) == 0$
$                   // ø⡼ɤRWXǽ
                    $page_table_entry = page_table_entry | (0x01 << 5)$
                $ELSE$
$                   // 桼⡼ɤRWXǽ
                    $page_table_entry = page_table_entry | (0x03 << 5)$
                $END$
            $ELSE$
                $IF (page_table_entry & 0x02) == 0$
$                   // ø⡼ɤRXǽ
                    $page_table_entry = page_table_entry | (0x00 << 5)$
                $ELSE$
$                   // 桼⡼ɤRXǽ
                    $page_table_entry = page_table_entry | (0x02 << 5)$
                $END$
            $END$

$           // ڡӥåȤ򥻥åȤ
$           // ٤4KB
            $page_table_entry = page_table_entry | (0x01 << 4)$

$           // å󥰲ǽӥåȤ򥻥åȤ
            $IF (MO.MEMATR[moid] & TA_UNCACHE) == 0$
                $page_table_entry = page_table_entry | (0x01 << 3)$
            $END$
$           // 饤ȥ롼ӥåȤ򥻥åȤ
$            $page_table_entry = page_table_entry | (0x01 << 0)$

$           // ƥӥåȤ򥻥åȤ
            $page_table_entry = page_table_entry | (0x01 << 2)$

$           // ͭӥåȤ򥻥åȤ
            $page_table_entry = page_table_entry | (0x01 << 8)$

            $page_table_entry = VALUE("", +page_table_entry)$
            $TAB$(uint32_t)$FORMAT("0x%xU", +page_table_entry)$
        $ELSE$
$           // 桼å
$           // 饤ȥ롼
$            $TAB$(uint32_t)$FORMAT("0x0000017dU")$
$           // 饤ȥХå
            $TAB$(uint32_t)$FORMAT("0x0000017cU")$
$           // åԲ
$            $TAB$(uint32_t)$FORMAT("0x00000174U")$
        $END$
    $END$
    $IF !LENGTH(MO.SUPPRESSLIMIT[moid])$
        $IF !LENGTH(MO.SUPPRESSSTART[moid])$,$NL$$END$
        $TAB$(uint32_t)0x0U
    $END$
$END$
$NL$};$NL$$NL$

$  桼ɥᥤ󤴤Ȥ˥ڡơ֥
$IF LENGTH(DOM.ID_LIST) > 0$
    $FOREACH domid DOM.ID_LIST$
        const uint32_t page_table_info_$domid - 1$[$tsize_meminib$] = {$NL$
        $IF !LENGTH(suppresszero)$
            $TAB$(uint32_t)0x0U,$NL$
        $END$
        $JOINEACH moid MO_MEMTOP_ORDER ",\n"$
            $page_table_entry = 0$
            $page_mp_info = 0$
            $IF !LENGTH(MO.SUPPRESSSTART[moid])$
                $IF MO.TYPE[moid] != TOPPERS_USTACK$
$                   // 桼åΰǤʤPTEL쥸˽
$                   // 桼åΰǤʤȤ򼨥ӥåȤΩƤ
$                   // 桼åΰξTCBΥɥ쥹񤭹
$                   // TCBΥɥ쥹P2ΰʤΤǥɥ쥹κǾ̥ӥåȤ1
$                   // äƤǤϺǾ̥ӥåȤ0ˤ
                    $page_table_entry = 0x00000000$

$                   // ݸǡΰ򥻥åȤ
                    $IF (MO.ACPTN1[moid] & DEFAULT_ACPTN[domid]) != 0$
$                       // ߲ǽ
                        $page_mp_info = page_mp_info | 0x01$
                    $END$
                    $IF (MO.ACPTN2[moid] & DEFAULT_ACPTN[domid]) != 0$
$                       // ɹߡ¹Բǽ
                        $page_mp_info = page_mp_info | 0x02$
                    $END$
                    $IF page_mp_info == 0x03$
$                       // 桼⡼ɤRWXǽ
                        $page_table_entry = page_table_entry | (0x03 << 5)$
                    $ELIF page_mp_info == 0x02$
$                       // 桼⡼ɤRXǽ
                        $page_table_entry = page_table_entry | (0x02 << 5)$
                    $ELIF page_mp_info == 0x00$
                        $IF (MO.MEMATR[moid] & TA_NOWRITE) == 0$
$                           // ø⡼ɤRWXǽ
                            $page_table_entry = page_table_entry | (0x01 << 5)$
                        $ELIF page_mp_info == 0x02$
$                           // ø⡼ɤRXǽ
                            $page_table_entry = page_table_entry | (0x00 << 5)$
                        $END$
                    $ELSE$
                        $ERROR$$FORMAT(_("non support memory protection attribute: ACPTN1 = %1%, ACPTN2 = %2%", MO.ACPTN1[moid], MO.ACPTN2[moid]))$$END$
                    $END$

$                   // ֥ͭӥåȤ򥻥åȤ
$                   // ̵°Υꥪ֥Ȥʤж֥ͭӥåȤΩƤ
                    $IF (MO.ACPTN2[moid] == DEFAULT_ACPTN[TDOM_NONE])$
                        $IF (((MO.MEMATR[moid] & TA_NOWRITE) != 0) || ((MO.ACPTN1[moid] == DEFAULT_ACPTN[TDOM_NONE])))$
                            $page_table_entry = page_table_entry | (0x01 << 1)$
                        $END$
                    $END$

$                   // ڡӥåȤ򥻥åȤ
$                   // ٤4KB
                    $page_table_entry = page_table_entry | (0x01 << 4)$

$                   // å󥰲ǽӥåȤ򥻥åȤ
                    $IF (MO.MEMATR[moid] & TA_UNCACHE) == 0$
                        $page_table_entry = page_table_entry | (0x01 << 3)$
                    $END$
$                   // 饤ȥ롼ӥåȤ򥻥åȤ
$                    $page_table_entry = page_table_entry | (0x01 << 0)$

$                   // ƥӥåȤ򥻥åȤ
                    $page_table_entry = page_table_entry | (0x01 << 2)$

$                   // ͭӥåȤ򥻥åȤ
                    $page_table_entry = page_table_entry | (0x01 << 8)$

                    $page_table_entry = VALUE("", +page_table_entry)$
                    $TAB$(uint32_t)$FORMAT("0x%xU", +page_table_entry)$
                $ELSE$
$                   // 桼å
$                   // 饤ȥ롼
$                    $TAB$(uint32_t)$FORMAT("0x0000017dU")$
$                   // 饤ȥХå
                    $TAB$(uint32_t)$FORMAT("0x0000017cU")$
$                   // åԲ
$                    $TAB$(uint32_t)$FORMAT("0x00000174U")$
                $END$
            $END$
            $IF !LENGTH(MO.SUPPRESSLIMIT[moid])$
                $IF !LENGTH(MO.SUPPRESSSTART[moid])$,$NL$$END$
                $TAB$(uint32_t)0x0U
            $END$
        $END$
    $NL$};$NL$$NL$
    $END$
$END$

$NL$


