$ ======================================================================
$
$   TOPPERS/HRP Kernel
$       Toyohashi Open Platform for Embedded Real-Time Systems/
$       High Reliable system Profile Kernel
$
$   Copyright (C) 2007-2012 by Embedded and Real-Time Systems Laboratory
$               Graduate School of Information Science, Nagoya Univ., JAPAN
$  
$   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
$   ܥեȥѤΤޤࡥʲƱˤѡʣ
$   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
$   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
$       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
$       ˴ޤޤƤ뤳ȡ
$   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
$       ѤǤǺۤˤϡۤȼɥȡ
$       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
$       ̵ݾڵǺܤ뤳ȡ
$   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
$       ѤǤʤǺۤˤϡΤ줫ξ
$       ȡ
$     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
$         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
$     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
$         𤹤뤳ȡ
$   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
$       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
$       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
$       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
$       դ뤳ȡ
$  
$   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
$   TOPPERSץȤϡܥեȥ˴ؤơλŪ
$   ФŬޤơʤݾڤԤʤޤܥեȥ
$   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
$   Ǥʤ
$
$   $Id: ldscript.tf 542 2011-10-25 03:29:15Z ertl-hiro $
$  
$ =====================================================================

$ =====================================================================
$ 󥫥ץȤ
$ =====================================================================
$FILE "ldscript.ld"$

$
$  åȰ¸OUTPUTҤ
$
$IF ISFUNCTION("GENERATE_OUTPUT")$
	$GENERATE_OUTPUT()$
$END$

$
$  MEMORYҤ
$
MEMORY {$NL$
$FOREACH reg REG.ORDER_LIST$
	$TAB$$FORMAT("%s : ORIGIN = 0x%x, LENGTH = 0x%x",
				REG.REGNAME[reg], +REG.BASE[reg], +REG.SIZE[reg])$$NL$
$END$
$IF ISFUNCTION("GENERATE_MEMORY")$
	$GENERATE_MEMORY()$
$END$
}$NL$
$NL$

$
$  åȰ¸PROVIDEҤ
$
$IF ISFUNCTION("GENERATE_PROVIDE")$
	$GENERATE_PROVIDE()$
$END$

$VMEM_KERNEL.ROM = "VROM_KERNEL"$
$VMEM_KERNEL.RAM = "VRAM_KERNEL"$
$VMEM_KERNEL.TOP = "0x80000000"$
$VMEM_KERNEL_UC.ROM = "VROM_KERNEL_UC"$
$VMEM_KERNEL_UC.RAM = "VRAM_KERNEL_UC"$
$VMEM_KERNEL_UC.TOP = "0xa0000000"$

$
$  ѿν
$
$reset_lma = 0$
$rom_count = 0$
$ram_count = 0$
$lma_rom_id = 0$

$
$  󥯻
$
SECTIONS {$NL$
$ åȰ¸Υ󵭽Ҥ
$IF ISFUNCTION("GENERATE_SECTION_FIRST")$
	$GENERATE_SECTION_FIRST()$
$END$

$IF TOPPERS_LABEL_ASM$
	$PREFIX_START = "___start_"$
	$PREFIX_END   = "___end_"$
	$PREFIX_LIMIT = "___limit_"$
$ELSE$
	$PREFIX_START = "__start_"$
	$PREFIX_END   = "__end_"$
	$PREFIX_LIMIT = "__limit_"$
$END$

$FOREACH moid MO_ORDER$
	$IF MO.LINKER[moid]$
$		// γϵҤ
		$IF (MO.SEFLAG[moid] & 0x01) != 0$
			$TAB$.$MO.SLABEL[moid]$ 
            $SPC$
            $IF (MO.SEFLAG[moid] & 0x40) == 0$
                $IF (MO.DOMAIN[moid] == TDOM_KERNEL) && (MO.MEMREG[moid] == STANDARD_ROM)$
                    (pre_limit_rom$rom_count - 1$ + 
                    $IF (MO.MEMATR[moid] & TA_UNCACHE) != 0$
                        $VMEM_KERNEL_UC.TOP$
                    $ELSE$
                        $VMEM_KERNEL.TOP$
                    $END$
                    )
                $ELIF (MO.DOMAIN[moid] == TDOM_KERNEL) && (MO.MEMREG[moid] == STANDARD_RAM)$
                    (pre_limit_ram$ram_count - 1$ + 
                    $IF (MO.MEMATR[moid] & TA_UNCACHE) != 0$
                        $VMEM_KERNEL_UC.TOP$
                    $ELSE$
                        $VMEM_KERNEL.TOP$
                    $END$
                    )
                $ELIF (MO.DOMAIN[moid] != TDOM_KERNEL) && (MO.MEMREG[moid] == STANDARD_RAM)$
                    (pre_limit_ram$ram_count - 1$)
                $END$
            $ELIF (MO.DOMAIN[moid] == TDOM_KERNEL) && (MO.MEMREG[moid] == STANDARD_ROM)$
                (pre_limit_rom_start + 
                $IF (MO.MEMATR[moid] & TA_UNCACHE) != 0$
                    $VMEM_KERNEL_UC.TOP$
                $ELSE$
                    $VMEM_KERNEL.TOP$
                $END$
                )
            $END$
            $SPC$
            : {$NL$
		$END$

$		// ȥꥪ֥Ȥγϥ٥
		$IF (MO.SEFLAG[moid] & 0x100) != 0$
			$TAB$$TAB$$PREFIX_START$srpw_all = .;$NL$
		$END$
		$IF (MO.SEFLAG[moid] & 0x10) != 0$
			$IF !EQ(MO.PLABEL[moid], "")$
				$TAB$$TAB$$PREFIX_START$$MO.PLABEL[moid]$ = .;$NL$
			$END$
		$END$
		$IF (MO.SEFLAG[moid] & 0x01) != 0$
			$IF !EQ(MO.SLABEL[moid], ALT(omit_start_slabel,""))$
				$TAB$$TAB$$PREFIX_START$$MO.SLABEL[moid]$ = .;$NL$
			$END$
		$END$
		$IF (MO.SEFLAG[moid] & 0x04) != 0$
			$IF (MO.SEFLAG[moid] & 0x01) == 0$
				$NL$
			$END$
			$IF !EQ(MO.MLABEL[moid], MO.SLABEL[moid])$
				$TAB$$TAB$$PREFIX_START$$MO.MLABEL[moid]$ = .;$NL$
			$END$
			$TAB$$TAB$
		$END$

$		// 󥯤ե뵭Ҥ
		$section_dscr = SECTION_DESCRIPTION(MO.SECTION[moid])$
		$IF MO.TYPE[moid] == TOPPERS_ATTMOD$
			$MO.MODULE[moid]$($section_dscr$)$SPC$
		$ELIF MO.TYPE[moid] == TOPPERS_ATTSEC$
			*($section_dscr$)$SPC$
		$ELSE$
			kernel_cfg.o($section_dscr$)$SPC$
		$END$

$		// ȥꥪ֥Ȥνλ٥
		$IF (MO.SEFLAG[moid] & 0x08) != 0$
			$NL$
			$IF !EQ(MO.MLABEL[moid], MO.SLABEL[moid])$
				$TAB$$TAB$$PREFIX_END$$MO.MLABEL[moid]$ = .;$NL$
			$END$
		$END$
		$IF (MO.SEFLAG[moid] & 0x02) != 0$
			$TAB$$TAB$$PREFIX_END$$MO.SLABEL[moid]$ = .;$NL$
		$END$
		$IF (MO.SEFLAG[moid] & 0x200) != 0$
			$TAB$$TAB$$PREFIX_END$srpw_all = .;$NL$
		$END$

        $IF MO.MEMREG[moid] == STANDARD_ROM$
$		    // 饤󵭽Ҥ
            $IF (MO.SEFLAG[moid] & 0x20) != 0$
                $TAB$$TAB$. = ALIGN($TARGET_PAGE_SIZE_STR$);$NL$
            $ELIF (MO.SEFLAG[moid] & 0x08) != 0$
                $TAB$$TAB$. = ALIGN($TARGET_SEC_ALIGN_STR$);$NL$
            $END$
        $END$

$		// νλҤ
		$IF (MO.SEFLAG[moid] & 0x02) != 0$
            $IF (MO.DOMAIN[moid] == TDOM_KERNEL)$
                $IF MO.MEMREG[moid] == STANDARD_ROM$
                    $IF (MO.MEMATR[moid] & TA_UNCACHE) != 0$
                        $TAB$} > $VMEM_KERNEL_UC.ROM$
                    $ELSE$
                        $TAB$} > $VMEM_KERNEL.ROM$
                    $END$
                    $SPC$AT > $REG.REGNAME[STANDARD_ROM]$
                $ELIF MO.MEMREG[moid] == STANDARD_RAM$
                    $IF (MO.MEMATR[moid] & TA_UNCACHE) != 0$
                        $TAB$} > $VMEM_KERNEL_UC.RAM$
                    $ELSE$
                        $TAB$} > $VMEM_KERNEL.RAM$
                    $END$
                $END$
            $ELSE$
                $TAB$} > $REG.REGNAME[MO.MEMREG[moid]]$
            $END$
			$IF !OMIT_IDATA$
				$IF !EQ(MO.ILABEL[moid], "")$
					$SPC$AT > $REG.REGNAME[STANDARD_ROM]$
					$reset_lma = 1$
				$ELIF reset_lma$
					$SPC$AT > $REG.REGNAME[MO.MEMREG[moid]]$
					$reset_lma = 0$
				$END$
			$END$$NL$
			$IF !OMIT_IDATA && !EQ(MO.ILABEL[moid], "")$
				$TAB$$PREFIX_START$$MO.ILABEL[moid]$ = LOADADDR(.$MO.SLABEL[moid]$);$NL$
			$END$
		$END$

        $IF MO.MEMREG[moid] != STANDARD_ROM$
$		    // 饤󵭽Ҥ
            $IF (MO.SEFLAG[moid] & 0x20) != 0$
                $TAB$. = ALIGN($TARGET_PAGE_SIZE_STR$);$NL$
            $ELIF (MO.SEFLAG[moid] & 0x08) != 0$
                $TAB$. = ALIGN($TARGET_SEC_ALIGN_STR$);$NL$
            $END$
        $END$

$		// ȥꥪ֥Ȥξ¥٥
		$IF (MO.SEFLAG[moid] & 0x08) != 0$
			$IF !EQ(MO.MLABEL[moid], MO.SLABEL[moid])$
$				// 󤬷³ƤˤϡTAB1Ľ
				$IF (MO.SEFLAG[moid] & 0x02) == 0$$TAB$$END$
				$TAB$$PREFIX_LIMIT$$MO.MLABEL[moid]$ = .;$NL$
			$END$
		$END$
		$IF (MO.SEFLAG[moid] & 0x02) != 0$
			$TAB$$PREFIX_LIMIT$$MO.SLABEL[moid]$ = .;$NL$
		$END$
		$IF (MO.SEFLAG[moid] & 0x20) != 0$
			$IF !EQ(MO.PLABEL[moid], "")$
				$TAB$$PREFIX_LIMIT$$MO.PLABEL[moid]$ = .;$NL$
			$END$
		$END$
		$IF (MO.SEFLAG[moid] & 0x200) != 0$
			$TAB$$PREFIX_LIMIT$srpw_all = .;$NL$
		$END$

		$IF (MO.SEFLAG[moid] & 0x02) != 0$
            $IF MO.MEMREG[moid] == STANDARD_ROM$
                $TAB$$PREFIX_START$$MO.SLABEL[moid]$_paddr = LOADADDR(.$MO.SLABEL[moid]$);$NL$
                $TAB$$PREFIX_END$$MO.SLABEL[moid]$_paddr = LOADADDR(.$MO.SLABEL[moid]$) + SIZEOF(.$MO.SLABEL[moid]$);$NL$
                $TAB$. = LOADADDR(.$MO.SLABEL[moid]$) + SIZEOF(.$MO.SLABEL[moid]$);$NL$
                $TAB$pre_limit_rom$rom_count$ = ALIGN($TARGET_PAGE_SIZE_STR$);$NL$
                $rom_count = rom_count + 1$

                $LMA_ROM.LSTART_SYMBOL[lma_rom_id] = ESCSTR(FORMAT("__start_%s_paddr", MO.SLABEL[moid]))$
                $LMA_ROM.LEND_SYMBOL[lma_rom_id] = ESCSTR(FORMAT("__end_%s_paddr", MO.SLABEL[moid]))$
                $LMA_ROM.VSTART_SYMBOL[lma_rom_id] = ESCSTR(FORMAT("__start_%s", MO.SLABEL[moid]))$
                $LMA_ROM.VEND_SYMBOL[lma_rom_id] = ESCSTR(FORMAT("__end_%s", MO.SLABEL[moid]))$
                $LMA_ROM.ORDER_LIST = APPEND(LMA_ROM.ORDER_LIST, lma_rom_id)$
                $lma_rom_id = lma_rom_id + 1$

            $ELIF MO.MEMREG[moid] == STANDARD_RAM$
                $IF MO.DOMAIN[moid] == TDOM_KERNEL$
                    $TAB$pre_limit_ram$ram_count$ = (. - 
                    $IF (MO.MEMATR[moid] & TA_UNCACHE) != 0$
                        $VMEM_KERNEL_UC.TOP$
                    $ELSE$
                        $VMEM_KERNEL.TOP$
                    $END$
                    );$NL$
                $ELSE$
                    $TAB$pre_limit_ram$ram_count$ = .;$NL$
                $END$
                $ram_count = ram_count + 1$
            $END$
			$NL$
		$END$
	$END$
$END$

$FOREACH lsid RANGE(1, numls)$
	$TAB$$LNKSEC.SECTION[lsid]$
    $IF LNKSEC.MEMREG[lsid] == STANDARD_ROM$
        $SPC$(pre_limit_rom$rom_count - 1$)$SPC$
    $ELIF LNKSEC.MEMREG[lsid] == STANDARD_RAM$
        $SPC$(pre_limit_ram$ram_count - 1$)$SPC$
    $END$
    : {$NL$
	$TAB$$TAB$*($LNKSEC.SECTION[lsid]$)$NL$
	$TAB$} > $REG.REGNAME[LNKSEC.MEMREG[lsid]]$$NL$
    $IF LNKSEC.MEMREG[lsid] == STANDARD_ROM$
        $TAB$pre_limit_rom$rom_count$ = .;$NL$
        $rom_count = rom_count + 1$
    $ELIF LNKSEC.MEMREG[lsid] == STANDARD_RAM$
        $TAB$pre_limit_ram$ram_count$ = .;$NL$
        $ram_count = ram_count + 1$
    $END$
	$NL$
$END$

$TAB$/DISCARD/ : {$NL$
$TAB$$TAB$*(.rel.dyn)$NL$
$TAB$}$NL$
$NL$

$TAB$/* DWARF debug sections.$NL$
$TAB$Symbols in the DWARF debugging sections are relative to $NL$
$TAB$the beginning of the section so we begin them at 0.  */$NL$
$NL$
$TAB$/* DWARF 1 */$NL$
$TAB$.debug          0 : { *(.debug) }$NL$
$TAB$.line           0 : { *(.line) }$NL$
$NL$
$TAB$/* GNU DWARF 1 extensions */$NL$
$TAB$.debug_srcinfo  0 : { *(.debug_srcinfo) }$NL$
$TAB$.debug_sfnames  0 : { *(.debug_sfnames) }$NL$
$NL$
$TAB$/* DWARF 1.1 and DWARF 2 */$NL$
$TAB$.debug_aranges  0 : { *(.debug_aranges) }$NL$
$TAB$.debug_pubnames 0 : { *(.debug_pubnames) }$NL$
$NL$
$TAB$/* DWARF 2 */$NL$
$TAB$.debug_info     0 : { *(.debug_info) }$NL$
$TAB$.debug_abbrev   0 : { *(.debug_abbrev) }$NL$
$TAB$.debug_line     0 : { *(.debug_line) }$NL$
$TAB$.debug_frame    0 : { *(.debug_frame) }$NL$
$TAB$.debug_str      0 : { *(.debug_str) }$NL$
$TAB$.debug_loc      0 : { *(.debug_loc) }$NL$
$TAB$.debug_macinfo  0 : { *(.debug_macinfo) }$NL$
$TAB$.debug_ranges   0 : { *(.debug_ranges) }$NL$
$NL$
$TAB$/* SGI/MIPS DWARF 2 extensions */$NL$
$TAB$.debug_weaknames 0 : { *(.debug_weaknames) }$NL$
$TAB$.debug_funcnames 0 : { *(.debug_funcnames) }$NL$
$TAB$.debug_typenames 0 : { *(.debug_typenames) }$NL$
$TAB$.debug_varnames  0 : { *(.debug_varnames) }$NL$
$NL$
}$NL$

$FILE "cfg2_out.tf"$
$$LMA.ORDER_LIST = { $LMA_ROM.ORDER_LIST$ }$$$NL$
$FOREACH lma_rom_id LMA_ROM.ORDER_LIST$
    $$LMA.START_DATA[$lma_rom_id$] = $LMA_ROM.VSTART_SYMBOL[lma_rom_id]$$$$NL$
    $$LMA.END_DATA[$lma_rom_id$]   = $LMA_ROM.VEND_SYMBOL[lma_rom_id]$$$$NL$
    $$LMA.START_IDATA[$lma_rom_id$] = $LMA_ROM.LSTART_SYMBOL[lma_rom_id]$$$$NL$
$END$

